import { createStore } from '@mpxjs/core'

export const app = createStore({
  state: {
    location: {
      lon: '',
      lat: '',
      position: ['', '']
    }
  },
  getters: {
    location: state => state.location
  },
  mutations: {
    setLocation (state, location) {
      Object.assign(state.location, location)
    }
  },
  actions: {
    getLocation ({ commit }) {
      return new Promise(resolve => {
        wx.getLocation({
          success (result) {
            const { latitude: lat, longitude: lon } = result
            const location = { lon, lat, position: [lon, lat] }
            commit('setLocation', location)
            resolve(location)
          },
          fail () {
            resolve()
          }
        })
      })
    }
  }
})
